<?php

namespace App\Models;

use Illuminate\Database\Eloquent\SoftDeletingTrait;

class Category extends Eloquent {

	protected $table = 'categories';
	public $timestamps = true;

	use SoftDeletingTrait;

	protected $dates = ['deleted_at'];
	protected $fillable = array('name');

	public function parent()
	{
		return $this->belongsTo('App\Models\Category');
	}

	public function subCategories()
	{
		return $this->hasMany('App\Models\Category', 'parent_id');
	}

	public function products()
	{
		return $this->belongsTo('App\Models\Product');
	}

}